Index: src/language/stats/rank.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.18
diff -b -w -U3 -r1.18 rank.q
--- src/language/stats/rank.q	5 Nov 2006 00:35:44 -0000	1.18
+++ src/language/stats/rank.q	11 Nov 2006 00:13:20 -0000
@@ -729,7 +729,6 @@
   return var;
 }
 
-int cmd_rank(struct dataset *ds);
 
 static void
 rank_cleanup(void)
@@ -758,14 +757,14 @@
 }
 
 int
-cmd_rank (struct dataset *ds)
+cmd_rank (struct lexer *lexer, struct dataset *ds)
 {
   bool result;
   struct variable *order;
   size_t i;
   n_rank_specs = 0;
 
-  if ( !parse_rank (ds, &cmd, NULL) )
+  if ( !parse_rank (lexer, ds, &cmd, NULL) )
     {
       rank_cleanup ();
     return CMD_FAILURE;
@@ -929,27 +928,28 @@
 /* Parser for the variables sub command  
    Returns 1 on success */
 static int
-rank_custom_variables (struct dataset *ds, struct cmd_rank *cmd UNUSED, void *aux UNUSED)
+rank_custom_variables (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd UNUSED, void *aux UNUSED)
 {
   static const int terminators[2] = {T_BY, 0};
 
-  lex_match('=');
+  lex_match (lexer, '=');
 
-  if ((token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL)
-      && token != T_ALL)
+  if ((lex_token (lexer) != T_ID || dict_lookup_var (dataset_dict (ds), lex_tokid (lexer)) == NULL)
+      && lex_token (lexer) != T_ALL)
       return 2;
 
-  sc = sort_parse_criteria (dataset_dict (ds), 
+  sc = sort_parse_criteria (lexer, dataset_dict (ds), 
 			    &src_vars, &n_src_vars, 0, terminators);
 
-  if ( lex_match(T_BY)  )
+  if ( lex_match (lexer, T_BY)  )
     {
-      if ((token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL))
+      if ((lex_token (lexer) != T_ID || dict_lookup_var (dataset_dict (ds), lex_tokid (lexer)) == NULL))
 	{
 	  return 2;
 	}
 
-      if (!parse_variables (dataset_dict (ds), &group_vars, &n_group_vars,
+      if (!parse_variables (lexer, dataset_dict (ds), 
+			    &group_vars, &n_group_vars,
 			    PV_NO_DUPLICATE | PV_NUMERIC | PV_NO_SCRATCH) )
 	{
 	  free (group_vars);
@@ -963,7 +963,7 @@
 
 /* Parse the [/rank INTO var1 var2 ... varN ] clause */
 static int
-parse_rank_function(struct dictionary *dict, struct cmd_rank *cmd UNUSED, enum RANK_FUNC f)
+parse_rank_function (struct lexer *lexer, struct dictionary *dict, struct cmd_rank *cmd UNUSED, enum RANK_FUNC f)
 {
   int var_count = 0;
   
@@ -975,16 +975,16 @@
   rank_specs[n_rank_specs - 1].destvars = 
 	    xcalloc (sc->crit_cnt, sizeof (struct variable *));
 	  
-  if (lex_match_id("INTO"))
+  if (lex_match_id (lexer, "INTO"))
     {
       struct variable *destvar;
 
-      while( token == T_ID ) 
+      while( lex_token (lexer) == T_ID ) 
 	{
 
-	  if ( dict_lookup_var (dict, tokid) != NULL )
+	  if ( dict_lookup_var (dict, lex_tokid (lexer)) != NULL )
 	    {
-	      msg(SE, _("Variable %s already exists."), tokid);
+	      msg(SE, _("Variable %s already exists."), lex_tokid (lexer));
 	      return 0;
 	    }
 	  if ( var_count >= sc->crit_cnt ) 
@@ -993,10 +993,10 @@
 	      return 0;
 	    }
 
-	  destvar = create_rank_variable (dict, f, src_vars[var_count], tokid);
+	  destvar = create_rank_variable (dict, f, src_vars[var_count], lex_tokid (lexer));
 	  rank_specs[n_rank_specs - 1].destvars[var_count] = destvar ;
 
-	  lex_get();
+	  lex_get (lexer);
 	  ++var_count;
 	}
     }
@@ -1006,74 +1006,74 @@
 
 
 static int
-rank_custom_rank(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_rank (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, RANK);
+  return parse_rank_function (lexer, dict, cmd, RANK);
 }
 
 static int
-rank_custom_normal(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_normal (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct  dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, NORMAL);
+  return parse_rank_function (lexer, dict, cmd, NORMAL);
 }
 
 static int
-rank_custom_percent(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_percent (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, PERCENT);
+  return parse_rank_function (lexer, dict, cmd, PERCENT);
 }
 
 static int
-rank_custom_rfraction(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_rfraction (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, RFRACTION);
+  return parse_rank_function (lexer, dict, cmd, RFRACTION);
 }
 
 static int
-rank_custom_proportion(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_proportion (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, PROPORTION);
+  return parse_rank_function (lexer, dict, cmd, PROPORTION);
 }
 
 static int
-rank_custom_n (struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_n (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, N);
+  return parse_rank_function (lexer, dict, cmd, N);
 }
 
 static int
-rank_custom_savage(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_savage (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  return parse_rank_function (dict, cmd, SAVAGE);
+  return parse_rank_function (lexer, dict, cmd, SAVAGE);
 }
 
 
 static int
-rank_custom_ntiles (struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_ntiles (struct lexer *lexer, struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
   struct dictionary *dict = dataset_dict (ds);
 
-  if ( lex_force_match('(') ) 
+  if ( lex_force_match (lexer, '(') ) 
     {
-      if ( lex_force_int() ) 
+      if ( lex_force_int (lexer) ) 
 	{
-	  k_ntiles = lex_integer ();
-	  lex_get();
-	  lex_force_match(')');
+	  k_ntiles = lex_integer (lexer);
+	  lex_get (lexer);
+	  lex_force_match (lexer, ')');
 	}
       else
 	return 0;
@@ -1081,5 +1081,5 @@
   else
     return 0;
 
-  return parse_rank_function(dict, cmd, NTILES);
+  return parse_rank_function (lexer, dict, cmd, NTILES);
 }
Index: src/language/stats/regression.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.37
diff -b -w -U3 -r1.37 regression.q
--- src/language/stats/regression.q	5 Nov 2006 00:35:44 -0000	1.37
+++ src/language/stats/regression.q	11 Nov 2006 00:13:20 -0000
@@ -916,31 +916,31 @@
 }
 
 static int
-regression_custom_export (struct dataset *ds UNUSED, struct cmd_regression *cmd UNUSED, void *aux UNUSED)
+regression_custom_export (struct lexer *lexer, struct dataset *ds UNUSED, struct cmd_regression *cmd UNUSED, void *aux UNUSED)
 {
   /* 0 on failure, 1 on success, 2 on failure that should result in syntax error */
-  if (!lex_force_match ('('))
+  if (!lex_force_match (lexer, '('))
     return 0;
 
-  if (lex_match ('*'))
+  if (lex_match (lexer, '*'))
     model_file = NULL;
   else
     {
-      model_file = fh_parse (FH_REF_FILE);
+      model_file = fh_parse (lexer, FH_REF_FILE);
       if (model_file == NULL)
 	return 0;
     }
 
-  if (!lex_force_match (')'))
+  if (!lex_force_match (lexer, ')'))
     return 0;
 
   return 1;
 }
 
 int
-cmd_regression (struct dataset *ds)
+cmd_regression (struct lexer *lexer, struct dataset *ds)
 {
-  if (!parse_regression (ds, &cmd, NULL))
+  if (!parse_regression (lexer, ds, &cmd, NULL))
     return CMD_FAILURE;
 
   models = xnmalloc (cmd.n_dependent, sizeof *models);
@@ -1004,20 +1004,20 @@
 
 /* Parser for the variables sub command */
 static int
-regression_custom_variables (struct dataset *ds, 
+regression_custom_variables (struct lexer *lexer, struct dataset *ds, 
 			     struct cmd_regression *cmd UNUSED,
 			     void *aux UNUSED)
 {
   const struct dictionary *dict = dataset_dict (ds);
 
-  lex_match ('=');
+  lex_match (lexer, '=');
 
-  if ((token != T_ID || dict_lookup_var (dict, tokid) == NULL)
-      && token != T_ALL)
+  if ((lex_token (lexer) != T_ID || dict_lookup_var (dict, lex_tokid (lexer)) == NULL)
+      && lex_token (lexer) != T_ALL)
     return 2;
 
 
-  if (!parse_variables (dict, &v_variables, &n_variables, PV_NONE))
+  if (!parse_variables (lexer, dict, &v_variables, &n_variables, PV_NONE))
     {
       free (v_variables);
       return 0;
Index: src/language/stats/sort-cases.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/sort-cases.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 sort-cases.c
--- src/language/stats/sort-cases.c	26 Oct 2006 06:16:36 -0000	1.6
+++ src/language/stats/sort-cases.c	11 Nov 2006 00:13:20 -0000
@@ -40,24 +40,24 @@
 
 /* Performs the SORT CASES procedures. */
 int
-cmd_sort_cases (struct dataset *ds)
+cmd_sort_cases (struct lexer *lexer, struct dataset *ds)
 {
   struct sort_criteria *criteria;
   bool success = false;
 
-  lex_match (T_BY);
+  lex_match (lexer, T_BY);
 
-  criteria = sort_parse_criteria (dataset_dict (ds), NULL, NULL, NULL, NULL);
+  criteria = sort_parse_criteria (lexer, dataset_dict (ds), NULL, NULL, NULL, NULL);
   if (criteria == NULL)
     return CMD_CASCADING_FAILURE;
 
-  if (get_testing_mode () && lex_match ('/')) 
+  if (get_testing_mode () && lex_match (lexer, '/')) 
     {
-      if (!lex_force_match_id ("BUFFERS") || !lex_match ('=')
-          || !lex_force_int ())
+      if (!lex_force_match_id (lexer, "BUFFERS") || !lex_match (lexer, '=')
+          || !lex_force_int (lexer))
         goto done;
 
-      min_buffers = max_buffers = lex_integer ();
+      min_buffers = max_buffers = lex_integer (lexer);
       allow_internal_sort = false;
       if (max_buffers < 2) 
         {
@@ -65,7 +65,7 @@
           goto done;
         }
 
-      lex_get ();
+      lex_get (lexer);
     }
 
   success = sort_active_file_in_place (ds, criteria);
@@ -76,6 +76,6 @@
   allow_internal_sort = true;
   
   sort_destroy_criteria (criteria);
-  return success ? lex_end_of_command () : CMD_CASCADING_FAILURE;
+  return success ? lex_end_of_command (lexer) : CMD_CASCADING_FAILURE;
 }
 
Index: src/language/stats/sort-criteria.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/sort-criteria.c,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 sort-criteria.c
--- src/language/stats/sort-criteria.c	27 Jun 2006 19:09:22 -0000	1.3
+++ src/language/stats/sort-criteria.c	11 Nov 2006 00:13:20 -0000
@@ -50,7 +50,7 @@
    
 */
 struct sort_criteria *
-sort_parse_criteria (const struct dictionary *dict,
+sort_parse_criteria (struct lexer *lexer, const struct dictionary *dict,
                      struct variable ***vars, size_t *var_cnt,
                      bool *saw_direction,
 		     const int *terminators
@@ -82,23 +82,23 @@
       enum sort_direction direction;
 
       /* Variables. */
-      if (!parse_variables (dict, vars, var_cnt,
+      if (!parse_variables (lexer, dict, vars, var_cnt,
 			    PV_NO_DUPLICATE | PV_APPEND | PV_NO_SCRATCH))
         goto error;
 
       /* Sort direction. */
-      if (lex_match ('('))
+      if (lex_match (lexer, '('))
 	{
-	  if (lex_match_id ("D") || lex_match_id ("DOWN"))
+	  if (lex_match_id (lexer, "D") || lex_match_id (lexer, "DOWN"))
 	    direction = SRT_DESCEND;
-	  else if (lex_match_id ("A") || lex_match_id ("UP"))
+	  else if (lex_match_id (lexer, "A") || lex_match_id (lexer, "UP"))
             direction = SRT_ASCEND;
           else
 	    {
 	      msg (SE, _("`A' or `D' expected inside parentheses."));
               goto error;
 	    }
-	  if (!lex_match (')'))
+	  if (!lex_match (lexer, ')'))
 	    {
 	      msg (SE, _("`)' expected."));
               goto error;
@@ -120,7 +120,7 @@
           c->dir = direction;
         }
     }
-  while (token != '.' && token != '/' && !is_terminator(token, terminators));
+  while (lex_token (lexer) != '.' && lex_token (lexer) != '/' && !is_terminator(lex_token (lexer), terminators));
 
   free (local_vars);
   return criteria;
Index: src/language/stats/sort-criteria.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/sort-criteria.h,v
retrieving revision 1.2
diff -b -w -U3 -r1.2 sort-criteria.h
--- src/language/stats/sort-criteria.h	16 Apr 2006 01:05:15 -0000	1.2
+++ src/language/stats/sort-criteria.h	11 Nov 2006 00:13:20 -0000
@@ -26,8 +26,9 @@
 
 struct variable;
 struct dictionary;
+struct lexer ;
 
-struct sort_criteria *sort_parse_criteria (const struct dictionary *,
+struct sort_criteria *sort_parse_criteria (struct lexer *, const struct dictionary *,
                                            struct variable ***, size_t *,
                                            bool *saw_direction,
 					   const int *terminators
Index: src/language/stats/t-test.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/t-test.q,v
retrieving revision 1.14
diff -b -w -U3 -r1.14 t-test.q
--- src/language/stats/t-test.q	5 Nov 2006 00:35:44 -0000	1.14
+++ src/language/stats/t-test.q	11 Nov 2006 00:13:21 -0000
@@ -154,7 +154,7 @@
 
 static struct pair *pairs=0;
 
-static int parse_value (union value * v, int type) ;
+static int parse_value (struct lexer *lexer, union value * v, int type) ;
 
 /* Structures and Functions for the Statistics Summary Box */
 struct ssbox;
@@ -258,11 +258,11 @@
 
 
 int
-cmd_t_test (struct dataset *ds)
+cmd_t_test (struct lexer *lexer, struct dataset *ds)
 {
   bool ok;
   
-  if ( !parse_t_test (ds, &cmd, NULL) )
+  if ( !parse_t_test (lexer, ds, &cmd, NULL) )
     return CMD_FAILURE;
 
   if (! cmd.sbc_criteria)
@@ -362,16 +362,16 @@
 }
 
 static int
-tts_custom_groups (struct dataset *ds, struct cmd_t_test *cmd UNUSED, void *aux UNUSED)
+tts_custom_groups (struct lexer *lexer, struct dataset *ds, struct cmd_t_test *cmd UNUSED, void *aux UNUSED)
 {
   int n_group_values=0;
 
-  lex_match('=');
+  lex_match (lexer, '=');
 
-  indep_var = parse_variable (dataset_dict (ds));
+  indep_var = parse_variable (lexer, dataset_dict (ds));
   if (!indep_var)
     {
-      lex_error ("expecting variable name in GROUPS subcommand");
+      lex_error (lexer, "expecting variable name in GROUPS subcommand");
       return 0;
     }
 
@@ -382,7 +382,7 @@
       return 0;
     }
 
-  if (!lex_match ('('))
+  if (!lex_match (lexer, '('))
     {
       if (indep_var->type == NUMERIC)
 	{
@@ -403,11 +403,11 @@
 	}
     }
 
-  if (!parse_value (&gp.v.g_value[0], indep_var->type))
+  if (!parse_value (lexer, &gp.v.g_value[0], indep_var->type))
       return 0;
 
-  lex_match (',');
-  if (lex_match (')'))
+  lex_match (lexer, ',');
+  if (lex_match (lexer, ')'))
     {
       if (indep_var->type != NUMERIC)
 	{
@@ -423,11 +423,11 @@
       return 1;
     }
 
-  if (!parse_value (&gp.v.g_value[1], indep_var->type))
+  if (!parse_value (lexer, &gp.v.g_value[1], indep_var->type))
     return 0;
 
   n_group_values = 2;
-  if (!lex_force_match (')'))
+  if (!lex_force_match (lexer, ')'))
     return 0;
 
   if ( n_group_values == 2 ) 
@@ -441,7 +441,7 @@
 
 
 static int
-tts_custom_pairs (struct dataset *ds, struct cmd_t_test *cmd UNUSED, void *aux UNUSED)
+tts_custom_pairs (struct lexer *lexer, struct dataset *ds, struct cmd_t_test *cmd UNUSED, void *aux UNUSED)
 {
   struct variable **vars;
   size_t n_vars;
@@ -451,10 +451,10 @@
   size_t n_after_WITH = SIZE_MAX;
   int paired ; /* Was the PAIRED keyword given ? */
 
-  lex_match('=');
+  lex_match (lexer, '=');
 
   n_vars=0;
-  if (!parse_variables (dataset_dict (ds), &vars, &n_vars,
+  if (!parse_variables (lexer, dataset_dict (ds), &vars, &n_vars,
 			PV_DUPLICATE | PV_NUMERIC | PV_NO_SCRATCH))
     {
       free (vars);
@@ -463,10 +463,10 @@
   assert (n_vars);
 
   n_before_WITH = 0;
-  if (lex_match (T_WITH))
+  if (lex_match (lexer, T_WITH))
     {
       n_before_WITH = n_vars;
-      if (!parse_variables (dataset_dict (ds), &vars, &n_vars,
+      if (!parse_variables (lexer, dataset_dict (ds), &vars, &n_vars,
 			    PV_DUPLICATE | PV_APPEND
 			    | PV_NUMERIC | PV_NO_SCRATCH))
 	{
@@ -476,7 +476,7 @@
       n_after_WITH = n_vars - n_before_WITH;
     }
 
-  paired = (lex_match ('(') && lex_match_id ("PAIRED") && lex_match (')'));
+  paired = (lex_match (lexer, '(') && lex_match_id (lexer, "PAIRED") && lex_match (lexer, ')'));
 
   /* Determine the number of pairs needed */
   if (paired)
@@ -563,25 +563,25 @@
   return 1;
 }
 
-/* Parses the current token (numeric or string, depending on type)
+/* Parses the current lex_token (lexer) (numeric or string, depending on type)
     value v and returns success. */
 static int
-parse_value (union value * v, int type )
+parse_value (struct lexer *lexer, union value * v, int type )
 {
   if (type == NUMERIC)
     {
-      if (!lex_force_num ())
+      if (!lex_force_num (lexer))
 	return 0;
-      v->f = tokval;
+      v->f = lex_tokval (lexer);
     }
   else
     {
-      if (!lex_force_string ())
+      if (!lex_force_string (lexer))
 	return 0;
-      strncpy (v->s, ds_cstr (&tokstr), ds_length (&tokstr));
+      strncpy (v->s, ds_cstr (lex_tokstr (lexer)), ds_length (lex_tokstr (lexer)));
     }
 
-  lex_get ();
+  lex_get (lexer);
 
   return 1;
 }
Index: src/language/tests/casefile-test.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/tests/casefile-test.c,v
retrieving revision 1.8
diff -b -w -U3 -r1.8 casefile-test.c
--- src/language/tests/casefile-test.c	5 Nov 2006 00:35:44 -0000	1.8
+++ src/language/tests/casefile-test.c	11 Nov 2006 00:13:21 -0000
@@ -45,7 +45,7 @@
 static void fail_test (const char *message, ...);
 
 int
-cmd_debug_casefile (struct dataset *ds UNUSED) 
+cmd_debug_casefile (struct lexer *lexer, struct dataset *ds UNUSED) 
 {
   static const size_t sizes[] =
     {
@@ -57,15 +57,15 @@
   int pattern;
 
   size_max = sizeof sizes / sizeof *sizes;
-  if (lex_match_id ("SMALL")) 
+  if (lex_match_id (lexer, "SMALL")) 
     {
       size_max -= 4;
       case_max = 511; 
     }
   else
     case_max = 4095;
-  if (token != '.')
-    return lex_end_of_command ();
+  if (lex_token (lexer) != '.')
+    return lex_end_of_command (lexer);
     
   for (pattern = 0; pattern < 7; pattern++) 
     {
Index: src/language/tests/float-format.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/tests/float-format.c,v
retrieving revision 1.1
diff -b -w -U3 -r1.1 float-format.c
--- src/language/tests/float-format.c	28 Oct 2006 04:01:55 -0000	1.1
+++ src/language/tests/float-format.c	11 Nov 2006 00:13:21 -0000
@@ -69,17 +69,17 @@
 /* Parses a floating-point format name into *FORMAT,
    and returns success. */
 static bool
-parse_float_format (enum float_format *format) 
+parse_float_format (struct lexer *lexer, enum float_format *format) 
 {
   size_t i;
 
   for (i = 0; i < format_cnt; i++)
-    if (lex_match_id (fp_formats[i].name)) 
+    if (lex_match_id (lexer, fp_formats[i].name)) 
       {
         *format = fp_formats[i].format;
         return true;
       }
-  lex_error ("expecting floating-point format identifier");
+  lex_error (lexer, "expecting floating-point format identifier");
   return false;
 }
 
@@ -101,25 +101,25 @@
    representation.  Also supports ordinary floating-point numbers
    written in decimal notation.  Returns success. */
 static bool
-parse_fp (struct fp *fp) 
+parse_fp (struct lexer *lexer, struct fp *fp) 
 {
-  if (lex_is_number ()) 
+  if (lex_is_number (lexer)) 
     {
-      double number = lex_number ();
+      double number = lex_number (lexer);
       fp->format = FLOAT_NATIVE_DOUBLE;
       memcpy (fp->data, &number, sizeof number);
-      lex_get ();
+      lex_get (lexer);
     }
-  else if (token == T_ID)
+  else if (lex_token (lexer) == T_ID)
     {
       size_t length;
       
-      if (!parse_float_format (&fp->format)
-          || !lex_force_match ('(')
-          || !lex_force_string ())
+      if (!parse_float_format (lexer, &fp->format)
+          || !lex_force_match (lexer, '(')
+          || !lex_force_string (lexer))
         return false;
 
-      length = ds_length (&tokstr);
+      length = ds_length (lex_tokstr (lexer));
       if (fp->format != FLOAT_HEX) 
         {
           if (length != float_get_size (fp->format)) 
@@ -129,7 +129,7 @@
               return false;
             }
           assert (length <= sizeof fp->data);
-          memcpy (fp->data, ds_data (&tokstr), length); 
+          memcpy (fp->data, ds_data (lex_tokstr (lexer)), length); 
         }
       else 
         {
@@ -138,16 +138,16 @@
               msg (SE, _("Hexadecimal floating constant too long."));
               return false;
             }
-          strncpy ((char *) fp->data, ds_cstr (&tokstr), sizeof fp->data);
+          strncpy ((char *) fp->data, ds_cstr (lex_tokstr (lexer)), sizeof fp->data);
         }
 
-      lex_get ();
-      if (!lex_force_match (')'))
+      lex_get (lexer);
+      if (!lex_force_match (lexer, ')'))
         return false;
     }
   else
     {
-      lex_error (NULL);
+      lex_error (lexer, NULL);
       return false;
     }
   return true;
@@ -235,7 +235,7 @@
 
 /* Executes the DEBUG FLOAT FORMAT command. */
 int
-cmd_debug_float_format (struct dataset *ds UNUSED) 
+cmd_debug_float_format (struct lexer *lexer, struct dataset *ds UNUSED) 
 {
   struct fp fp[16];
   size_t fp_cnt = 0;
@@ -249,30 +249,30 @@
           msg (SE, _("Too many values in single command."));
           return CMD_FAILURE;
         }
-      if (!parse_fp (&fp[fp_cnt++]))
+      if (!parse_fp (lexer, &fp[fp_cnt++]))
         return CMD_FAILURE;
 
-      if (token == '.' && fp_cnt > 1)
+      if (lex_token (lexer) == '.' && fp_cnt > 1)
         break;
-      else if (!lex_force_match ('='))
+      else if (!lex_force_match (lexer, '='))
         return CMD_FAILURE;
       
       if (fp_cnt == 1) 
         {
-          if (lex_match ('='))
+          if (lex_match (lexer, '='))
             bijective = true;
-          else if (lex_match (T_GT))
+          else if (lex_match (lexer, T_GT))
             bijective = false;
           else 
             {
-              lex_error (NULL);
+              lex_error (lexer, NULL);
               return CMD_FAILURE;
             }
         }
       else 
         {
-          if ((bijective && !lex_force_match ('='))
-              || (!bijective && !lex_force_match (T_GT)))
+          if ((bijective && !lex_force_match (lexer, '='))
+              || (!bijective && !lex_force_match (lexer, T_GT)))
             return CMD_FAILURE;
         }
     }
Index: src/language/tests/moments-test.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/tests/moments-test.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 moments-test.c
--- src/language/tests/moments-test.c	26 Oct 2006 06:16:36 -0000	1.6
+++ src/language/tests/moments-test.c	11 Nov 2006 00:13:21 -0000
@@ -31,27 +31,27 @@
 #define _(msgid) gettext (msgid)
 
 static bool
-read_values (double **values, double **weights, size_t *cnt) 
+read_values (struct lexer *lexer, double **values, double **weights, size_t *cnt) 
 {
   size_t cap = 0;
 
   *values = NULL;
   *weights = NULL;
   *cnt = 0;
-  while (lex_is_number ())
+  while (lex_is_number (lexer))
     {
-      double value = tokval;
+      double value = lex_tokval (lexer);
       double weight = 1.;
-      lex_get ();
-      if (lex_match ('*'))
+      lex_get (lexer);
+      if (lex_match (lexer, '*'))
         {
-          if (!lex_is_number ())
+          if (!lex_is_number (lexer))
             {
-              lex_error (_("expecting weight value"));
+              lex_error (lexer, _("expecting weight value"));
               return false;
             }
-          weight = tokval;
-          lex_get ();
+          weight = lex_tokval (lexer);
+          lex_get (lexer);
         }
 
       if (*cnt >= cap) 
@@ -70,7 +70,7 @@
 }
 
 int
-cmd_debug_moments (struct dataset *ds UNUSED) 
+cmd_debug_moments (struct lexer *lexer, struct dataset *ds UNUSED) 
 {
   int retval = CMD_FAILURE;
   double *values = NULL;
@@ -80,22 +80,22 @@
   size_t cnt;
   size_t i;
 
-  if (lex_match_id ("ONEPASS"))
+  if (lex_match_id (lexer, "ONEPASS"))
     two_pass = 0;
-  if (token != '/') 
+  if (lex_token (lexer) != '/') 
     {
-      lex_force_match ('/');
+      lex_force_match (lexer, '/');
       goto done;
     }
-  fprintf (stderr, "%s => ", lex_rest_of_line (NULL));
-  lex_get ();
+  fprintf (stderr, "%s => ", lex_rest_of_line (lexer, NULL));
+  lex_get (lexer);
 
   if (two_pass) 
     {
       struct moments *m = NULL;
   
       m = moments_create (MOMENT_KURTOSIS);
-      if (!read_values (&values, &weights, &cnt)) 
+      if (!read_values (lexer, &values, &weights, &cnt)) 
         {
           moments_destroy (m);
           goto done; 
@@ -112,7 +112,7 @@
       struct moments1 *m = NULL;
   
       m = moments1_create (MOMENT_KURTOSIS);
-      if (!read_values (&values, &weights, &cnt)) 
+      if (!read_values (lexer, &values, &weights, &cnt)) 
         {
           moments1_destroy (m);
           goto done; 
@@ -136,7 +136,7 @@
     }
   fprintf (stderr, "\n");
 
-  retval = lex_end_of_command ();
+  retval = lex_end_of_command (lexer);
   
  done:
   free (values);
Index: src/language/tests/pool-test.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/tests/pool-test.c,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 pool-test.c
--- src/language/tests/pool-test.c	26 Oct 2006 06:16:36 -0000	1.3
+++ src/language/tests/pool-test.c	11 Nov 2006 00:13:21 -0000
@@ -32,7 +32,7 @@
 /* Self-test routine.
    This is not exhaustive, but it can be useful. */
 int
-cmd_debug_pool (struct dataset *ds UNUSED)
+cmd_debug_pool (struct lexer *lexer UNUSED, struct dataset *ds UNUSED)
 {
   int seed = time (0) * 257 % 32768;
 
Index: src/language/utilities/date.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/date.c,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 date.c
--- src/language/utilities/date.c	26 Oct 2006 06:16:36 -0000	1.3
+++ src/language/utilities/date.c	11 Nov 2006 00:13:21 -0000
@@ -27,10 +27,10 @@
 
 /* Stub for USE command. */
 int
-cmd_use (struct dataset *ds UNUSED) 
+cmd_use (struct lexer *lexer, struct dataset *ds UNUSED) 
 {
-  if (lex_match (T_ALL))
-    return lex_end_of_command ();
+  if (lex_match (lexer, T_ALL))
+    return lex_end_of_command (lexer);
 
   msg (SW, _("Only USE ALL is currently implemented."));
   return CMD_FAILURE;
Index: src/language/utilities/echo.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/echo.c,v
retrieving revision 1.4
diff -b -w -U3 -r1.4 echo.c
--- src/language/utilities/echo.c	26 Oct 2006 06:16:36 -0000	1.4
+++ src/language/utilities/echo.c	11 Nov 2006 00:13:21 -0000
@@ -29,11 +29,11 @@
 
 /* Echos a string to the output stream */
 int
-cmd_echo (struct dataset *ds UNUSED)
+cmd_echo (struct lexer *lexer, struct dataset *ds UNUSED)
 {
   struct tab_table *tab;
 
-  if (token != T_STRING) 
+  if (lex_token (lexer) != T_STRING) 
     return CMD_FAILURE;
   
   tab = tab_create(1, 1, 0);
@@ -41,7 +41,7 @@
   tab_dim (tab, tab_natural_dimensions);
   tab_flags (tab, SOMF_NO_TITLE );
 
-  tab_text(tab, 0, 0, 0, ds_cstr (&tokstr));
+  tab_text(tab, 0, 0, 0, ds_cstr (lex_tokstr (lexer)));
 
   tab_submit(tab);
 
Index: src/language/utilities/include.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/include.c,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 include.c
--- src/language/utilities/include.c	26 Oct 2006 06:16:36 -0000	1.5
+++ src/language/utilities/include.c	11 Nov 2006 00:13:21 -0000
@@ -31,20 +31,20 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_include (struct dataset *ds UNUSED)
+cmd_include (struct lexer *lexer, struct dataset *ds UNUSED)
 {
   /* Skip optional FILE=. */
-  if (lex_match_id ("FILE"))
-    lex_match ('=');
+  if (lex_match_id (lexer, "FILE"))
+    lex_match (lexer, '=');
 
   /* File name can be identifier or string. */
-  if (token != T_ID && token != T_STRING) 
+  if (lex_token (lexer) != T_ID && lex_token (lexer) != T_STRING) 
     {
-      lex_error (_("expecting file name")); 
+      lex_error (lexer, _("expecting file name")); 
       return CMD_CASCADING_FAILURE;
     }
-  getl_include_syntax_file (ds_cstr (&tokstr));
+  getl_include_syntax_file (ds_cstr (lex_tokstr (lexer)));
 
-  lex_get ();
-  return lex_end_of_command ();
+  lex_get (lexer);
+  return lex_end_of_command (lexer);
 }
Index: src/language/utilities/permissions.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/permissions.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 permissions.c
--- src/language/utilities/permissions.c	26 Oct 2006 06:16:36 -0000	1.6
+++ src/language/utilities/permissions.c	11 Nov 2006 00:13:21 -0000
@@ -42,32 +42,32 @@
 
 /* Parses the PERMISSIONS command. */
 int
-cmd_permissions (struct dataset *ds UNUSED)
+cmd_permissions (struct lexer *lexer, struct dataset *ds UNUSED)
 {
   char  *fn = 0;
 
-  lex_match ('/');
+  lex_match (lexer, '/');
 
-  if (lex_match_id ("FILE"))
-    lex_match ('=');
+  if (lex_match_id (lexer, "FILE"))
+    lex_match (lexer, '=');
 
-  fn = ds_xstrdup (&tokstr);
-  lex_force_match(T_STRING);
+  fn = ds_xstrdup (lex_tokstr (lexer));
+  lex_force_match (lexer, T_STRING);
 
 
-  lex_match ('/');
+  lex_match (lexer, '/');
   
-  if ( ! lex_match_id ("PERMISSIONS"))
+  if ( ! lex_match_id (lexer, "PERMISSIONS"))
     goto error;
 
-  lex_match('=');
+  lex_match (lexer, '=');
 
-  if ( lex_match_id("READONLY"))
+  if ( lex_match_id (lexer, "READONLY"))
     {
       if ( ! change_permissions(fn, PER_RO ) ) 
 	goto error;
     }
-  else if ( lex_match_id("WRITEABLE"))
+  else if ( lex_match_id (lexer, "WRITEABLE"))
     {
       if ( ! change_permissions(fn, PER_RW ) ) 
 	goto error;
